#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include "filerall.h"

static void read_filep_real(FILE *f,char**buf, size_t *len)
{
    char *xb;
    static const int rsize=2000;
    size_t r, pos= *len;
    int eno;

    xb= malloc(rsize);
    r= fread(xb, 1, rsize, f);
    *len+= r;
    if (r==rsize)
    {
        read_filep_real(f, buf,len);
    }
    else
    {
       if (ferror(f)) 
       {
         eno= errno;
         free(xb);
         errno= eno;
         *buf= 0;
         return ;
       }
       *buf= malloc(*len+1);
    }
        
    memcpy(*buf + pos, xb, r);
    free(xb);
}

static void read_filep(FILE *f,char**buf, size_t *len) {
    *len= 0;
    read_filep_real(f,buf,len);
    if (*buf)
       (*buf)[*len]= 0;
}

char* file_read_all(char *name, size_t *len)
{
   FILE *f;
   char *buf;
   f= fopen(name,"r");
   if (!f) return NULL;
   read_filep(f, &buf, (size_t*) len);
   fclose(f);
   return buf;
}
