#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include "x-basics.h"
#include "x-events.h"
#include "bfont.h"
#include "fsel.h"
#include "graymap.h"
#include "txtren.h"
#include "list.h"
#include "imgload.h"

char *icons[]=
{
"system-file-manager.png",
"system-software-install.png",
"system-software-update.png",
"system-users.png",
"terminal.png",
"text-editor.png",
"update-manager.png",
"user-info.png",
"utilities-system-monitor.png",
"utilities-terminal.png",
"volume-knob.png",
"wallpaper.png",
"web-browser.png",
"xfce-filemanager.png",
"xfce-terminal.png",
"xfce4-backdrop.png",
"xfce4-mixer.png",
"xfwm4.png",
NULL
};

void append(list_t *L, char *x)
{
  char buf[2000];
  unsigned int w,h,*d;

  sprintf(buf,"/usr/share/icons/gnome/16x16/apps/%s",x);
  if (load_icon(buf, 16, 16, &w, &h, &d))
    list_append(L, list_item_new(NULL, 0,0, x, x));
  else {
    list_append(L, list_item_new(d, w,h, x, x));
    free(d);
  }
}

void iclick(void *arg, list_t *L, list_item_t *li)
{
  printf("clicked item: %s\n", (char*) list_item_data(li));
}

void dclick(void *arg, list_t *L, list_item_t *li)
{
  printf("double clicked item: %s\n", (char*) list_item_data(li));
}


int main()
{
  if (init_display(NULL)) return 1;

  font_init();
  init_builtin_font();
  graymap_init(x_red_shift,x_green_shift,x_blue_shift);

  list_t *L;
  L= list_new(x_root_window, 300, 200, 120, 200, iclick, dclick, NULL);

  int i;
  for(i=0;icons[i];i++)
    append(L, icons[i]);

  while(1)
  {
     XEvent event;
     XNextEvent(x_display,&event);
     handle_registered_event(&event);
  }
  return 0;
}
