#include <stdint.h>
#include <stdio.h>
#include <X11/Xlib.h>
#include "x-basics.h"
#include "x-props.h"
#include "x-events.h"
#include "bfont.h"
#include "graymap.h"
#include "txtren.h"
#include "config.h"
#include "medit.h"

cfg_top_t cfg;

static int done;

void finish(void *ignore)
{
  done= 1;
}

int main()
{
  if (init_display(NULL)) return 1;

  x_atoms_init();
  font_init();
  init_builtin_font();
  graymap_init(x_red_shift,x_green_shift,x_blue_shift);

  edit_app_menu(x_root_window, 300, 200, "../appmenu/out.tt", &cfg,
                finish, NULL);

  while(!done)
  {
     XEvent event;
     XNextEvent(x_display,&event);
     handle_registered_event(&event);
  }
  return 0;
}

