#include <stdint.h>
#include <stdio.h>
#include <X11/Xlib.h>
#include "x-basics.h"
#include "x-props.h"
#include "menu.h"
#include "imgload.h"
#include "appmenu.h"

void menu_make(menu_t *M, amenu_t *A)
{
  unsigned int W,H, *D;
  menu_t *S;
  aitem_t *ai;

  for(ai=A->items.next;ai!=&A->items;ai=ai->next)
  {
    switch(ai->type)
    {
    case 0:
      if (load_icon(ai->icon, 16, 16, &W, &H, &D))
         menu_add_item(M, 0,0, NULL, ai->name, 1);
      else
         menu_add_item(M, W,H, D, ai->name, 1);
      break;
    case 1:
      S= menu_start();
      if (load_icon(ai->icon, 16, 16, &W, &H, &D))
         menu_add_sub(M, 0,0, NULL, ai->name, S);
      else
         menu_add_sub(M, W,H, D, ai->name, S);
      menu_make(S, ai->sub);
      menu_end(S);
      break;
    case 2:
      menu_add_sep(M);
      break;
    }
  }
}

int main()
{
  menu_t *M;
  amenu_t *A;

  int i;
  FILE *f;

  if (init_display(NULL)) return 1;
  x_atoms_init();

  font_init();
  menu_init("/home/dodo/.fonts/Arimo-Regular.ttf",10);
  graymap_init(x_red_shift,x_green_shift,x_blue_shift);

  A= read_app_menu("../appmenu/out.tt", NULL);

  M= menu_start();
  menu_make( M, A);
  menu_end(M);

  Window Mwindow; unsigned int Mevent;
  menu_display_top(M,100, 100, &Mwindow, &Mevent); 
  while(1) 
  {
    XEvent event;
    XNextEvent(x_display,&event);
    if (event.xany.type==Mevent && event.xany.window==Mwindow)
    {
      printf("selected action: %d\n", menu_get_selected(M));
      break;
    }
    handle_registered_event(&event);

  }
  return 0;
}

