#include <stdint.h>
#include <stdio.h>
#include <unistd.h>
#include <X11/Xlib.h>
#include "x-basics.h"
#include "x-props.h"
#include "config.h"
#include "menu.h"
#include "imgload.h"
#include "appmenu.h"
#include "bfont.h"
#include "txtren.h"
#include "graymap.h"
#include "panel.h"

cfg_top_t cfg;

void execute_program(char *x)
{
  char *argv[10];
  if (!x) return ;
  if (fork()) return ;
  argv[0]= "/bin/sh";
  argv[1]= "-c";
  argv[2]= x;
  argv[3]= NULL;
  execvp(argv[0], argv);
}

int main()
{
  if (init_display(NULL)) return 1;
  cfg_parse_top("test.cfg",&cfg);
  x_atoms_init();

  font_init();
  init_builtin_font();
  menu_init(&cfg.menu_style);
  graymap_init(x_red_shift,x_green_shift,x_blue_shift);

  init_panel("../appmenu/out.tt", &cfg);

  panel_loop();
  return 0;
}

