#include <stdint.h>
#include <stdio.h>

#include <sys/ipc.h>
#include <sys/shm.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/extensions/XShm.h>


#include "x-basics.h"
#include "x-events.h"
#include "x-image.h"
#include "bfont.h"
#include "graymap.h"
#include "txtren.h"
#include "txent.h"
#include "x-keyboard.h"

Window    mw;
ximage_t *mi;

#define TS_w   400
#define TS_h   200
#define TS_x   50
#define TS_y   50

#define EN_w   340
#define EN_h   30
#define EN_x   30
#define EN_y   30

void mk_window()
{
  XSetWindowAttributes attribs;

  attribs.background_pixmap= None;
  mw= XCreateWindow(x_display, x_root_window, TS_x, TS_y, TS_w, TS_h,
                            0, x_depth, InputOutput, x_visual,
                            CWBackPixmap, &attribs);
  XSelectInput(x_display, mw, ExposureMask |  KeyPressMask |
                       ButtonPressMask | ButtonReleaseMask);

  XMapWindow(x_display, mw);

  mi= create_image(TS_w, TS_h);
  fill_rect(mi->data, TS_w, TS_h, 0,0, TS_w, TS_h, 0xffffff);
  draw_rect(mi->data, TS_w, TS_h, EN_x-1, EN_y-1, EN_w+2, EN_h+2, 0);
}

int main()
{
  x_keyboard_t *kb;
  if (init_display(NULL)) return 1;

  font_init();
  init_builtin_font();
  graymap_init(x_red_shift,x_green_shift,x_blue_shift);

  mk_window();

  kb= x_keyboard_init(mw);

  text_entry_t *te;

  KeySym sym; uint32_t *str; size_t nstr;

  te= text_entry_init(mw, mi, EN_x, EN_y, EN_w, EN_h, "Hello Worldy!",1);

  while(1)
  {
     XEvent event;
     XNextEvent(x_display,&event);
     if (event.xany.window==mw)
     {
      switch(event.type)
      {
       case Expose:
         put_image(mw, event.xexpose.x, event.xexpose.y,
                   mi, event.xexpose.x, event.xexpose.y,
                           event.xexpose.width, event.xexpose.height);
         continue;
       case KeyPress:
         if (x_keyboard_event(kb, &event, &sym, &str, &nstr))
           text_entry_key(te, sym, str, nstr); 
         continue;
      }
      continue;
     }
     handle_registered_event(&event);
  }
  return 0;
}

